
globals
;We define global variables(グローバル変数定義)
[
  RCT RCTnum
  Average-S-rate Average-V-rate Average-B-rate Average-utility
  CooperateAgentNum DefectAgentNum
  PunisherNum PunishedNum
  overSDagentNum underSDagentNum
  comulative-variance standardDeviation　winner S-rate
  norm-establishment norm-collapse
]

turtles-own
;We define turtle`s variables(タートル変数定義)
[
  utility
  V-rate B-rate C-rate L-rate dtfg-i dtfg-j culture link-list
  labelTemp dtfgiTemp dtfgjTemp
  SDstatus1 SDstatus2
  B-rate-initial B-rate-evolution B-rate-mutate V-rate-initial V-rate-evolution V-rate-mutate
  CooperateNum DefectNum AgentPunisherNum AgentPunishedNum
]


to setup
  clear-all
  setup-parameters ;Procedure to set parameters(パラメータ設定プロシージャ)
  setup-turtles ;Prodedure to set parameters(タートル設定プロシージャ)
  reset-ticks
end

;Procedure to set Patch (パッチ設定プロシージャ)
to setup-parameters

  ifelse model-change = "axelrod"
  [
    set RCT 4 ;repeat times of "go"-4times following Axelrod(goのリピート回数→axelrodに従い4回）
  ][
    set RCT 4 ;repeat times of "go"-4times following Axelrod(goのリピート回数→axelrodに従い4回）
  ]
end


to setup-turtles
  ;Procedure to set turtles (タートル設定プロシージャ)
  ;Create "number" of turtles (number数のタートルを生成)
  create-turtles number

  ;Set initial values (初期値を設定)
  ask turtles [
    set utility 0

  ;*set utility from 1/7 to 7/7
      set V-rate (initial-V-rate) / 7
      set B-rate (initial-B-rate) / 7
  ]

end

to go
  if ticks >= length-of-run [ stop ] ;input指定回で終了
  game ;4回ゲームを繰り返す
  calcStandardDeviation ;*Caluculate standard deviation (標準偏差を計算する)
  evolution ;利得を評価し進化する

  tick
end

to game
  ;Average-*-rateの初期化
  set Average-S-rate 0
  set Average-V-rate 0
  set Average-B-rate 0
  set Average-utility 0
  set comulative-variance 0
  set standardDeviation 0
  set CooperateAgentNum 0
  set DefectAgentNUm 0
  set PunisherNum 0
  set PunishedNum 0
  set RCTnum 0

  ask turtles
  [
    set utility 0
    set CooperateNum 0
    set DefectNum 0
    set AgentPunisherNum 0
    set AgentPunishedNum 0
  ]

  repeat RCT [ defect-cooperate ]

end


to defect-cooperate
  ;We generate the rate to be seen, "S-rate"
  set S-rate random-float 1
  ;If model is "collusion model", we omit the rate to be seen, "S-rate".
  if S-rate-change = false [ set S-rate 1 ]
  set RCTnum RCTnum + 1
  set CooperateAgentNum 0
  set DefectAgentNum 0
  set PunishedNum 0
  set PunisherNum 0

  ask turtles
  [
    ;We reset detection frag, dtfg-*. (発見フラグをリセット)
    set dtfg-i 0
    set dtfg-j 0
    ;*We reset the label. (ラベルをリセット)
    set label ""

    ifelse random-float 1 >= B-rate [
      ;-----------Cooperate Game (協調ゲーム)----------
      ;Axelrods norms game model
      ifelse model-change = "axelrod"
      [
        ;Cooperate agents pay cost F. (協調するとiはコストFを払う)
        set utility utility + UF
        ;Other agents get payoff M (他の人は利得Mを得る)
        ask other turtles [set utility utility + UM]
         ;*Cooperate agents get label "cooperate". (協調タートルのラベル付け)
        set label "cooperate"
        set CooperateNum CooperateNum + 1
      ][
        ;*Cooperate agents get label "cooperate". (協調タートルのラベル付け)
        set label "cooperate"
        set CooperateNum CooperateNum + 1
      ]
    ][
      ;-----------Defect Game (裏切りゲーム)----------
      ifelse model-change = "axelrod"
      [
        ;Defect agents get payoff T in the case to defect. (裏切るとiは利得Tを得る)
        set utility utility + UT
        ;Other agents get payoff M. (他の人は損害Hを得る)
        ask other turtles [set utility utility + UH]
        ;*Defect agents get label "defect".(裏切りタートルのラベル付け)
        set label  "defect"
        set DefectNum DefectNum + 1
      ][
        ;*Defect agents get label "defect".(裏切りタートルのラベル付け)
        set label "defect"
        set DefectNum DefectNum + 1
      ]
    ]
  ]

  ;-----------calculate payoff in the case of collusion model(利得計算)----------
  if model-change = "collusion"
      [
        let cooperate-turtles turtles with [label = "cooperate"]
        let defect-turtles turtles with [label = "defect"]
        if any? cooperate-turtles [
            ;*If all agents are "cooperate"(全てのエージェントが協力であれば)，
            ifelse count cooperate-turtles = number [
              ifelse model-change-2 = "strong" [
              ;*In the case of "strong cartels", all agents get UF(reword) divided by agents number.
              ;(strong cartelsの場合は，談合利得をエージェントで分け合う．)
              ask turtles [ set utility utility + (UF / number) ]
            ][
              ;In the case of "weak cartels", winner, who is selected in order, get UF(reword).
              ;(weak cartelsの場合は，協調すると勝利者は利得Fを得る)
              ifelse winner > number - 1 [
                ask turtle 0 [ set utility utility + UF ]
                ;ask other turtles [ set utility utility + UM ]
                set winner 1
              ][
                ask turtle winner [ set utility utility + UF ]
                ;ask other turtles [ set utility utility + UM ]
                set winner winner + 1
              ]
            ]
          ][
            ;ask cooperate-turtles [set utility utility + UH  ]
          ]
        ]
          if any? defect-turtles [
          ;*If there is even one defect agent, the winner is randomly selected from defect agents.
          ;(裏切りエージェントの中から，落札者(勝利者)エージェントをランダムに決定する
            ask one-of defect-turtles [ set utility utility + UT ]
            ;ask other defect-turtles [ set utility utility + UH ]
          ]
        ]

  ask turtles with [label = "defect"]
  [
    ;------norms-game(規範ゲーム)------;
    let group-j  other turtles
    ;set own to turtle-i(自分をturtle-iに代入)
    let turtle-i turtle who
    ;to norms-game(裏切り規範ゲームへ)
      norm-game-defection turtle-i group-j
  ]

  ;procudure to duscharge data(情報出力用処理)
  if data_discharge_per_steps = True
  [
    set CooperateAgentNum CooperateAgentNum + count turtles with [label = "cooperate"]
    set DefectAgentNum DefectAgentNum + count turtles with [label = "defect"]

    set PunishedNum PunishedNum + count turtles with [dtfg-i > 0]
    set PunisherNum PunisherNum + count turtles with [dtfg-j > 0]

    let resultGlobal-list []
    set resultGlobal-list lput number resultGlobal-list
    set resultGlobal-list lput UP resultGlobal-list
    set resultGlobal-list lput behaviorspace-run-number resultGlobal-list
    set resultGlobal-list lput ticks resultGlobal-list
    set resultGlobal-list lput RCTnum resultGlobal-list
    set resultGlobal-list lput CooperateAgentNum resultGlobal-list
    set resultGlobal-list lput DefectAgentNum resultGlobal-list
    set resultGlobal-list lput PunishedNum resultGlobal-list
    set resultGlobal-list lput PunisherNum resultGlobal-list

    file-open "ExperimentGlobal.txt"
    file-show resultGlobal-list
    file-close

    ask turtles
    [
      let resultAgent-list[]
      set resultAgent-list lput number resultAgent-list
      set resultAgent-list lput UP resultAgent-list
      set resultAgent-list lput behaviorspace-run-number resultAgent-list
      set resultAgent-list lput ticks resultAgent-list
      set resultAgent-list lput RCTnum resultAgent-list

      ifelse label = "cooperate"
      [
        set labelTemp 0
      ][
        set labelTemp 1
      ]
      set resultAgent-list lput labelTemp resultAgent-list

      ifelse dtfg-i > 0
      [
        set dtfgiTemp 1
      ][
        set dtfgiTemp 0
      ]
      set resultAgent-list lput dtfgiTemp resultAgent-list

      ifelse dtfg-j > 0
      [
        set dtfgjTemp 1
      ][
        set dtfgjTemp 0
      ]
      set resultAgent-list lput dtfgjTemp resultAgent-list

      set resultAgent-list lput utility resultAgent-list
      set resultAgent-list lput B-rate resultAgent-list
      set resultAgent-list lput V-rate resultAgent-list

      file-open "ExperimentAgent.txt"
      file-show resultAgent-list

    file-close
    ]
  ]

end


to norm-game-defection [turtle-i group-j]
;------norms-game(裏切り規範ゲーム)------
  ask group-j
  [
    ;発見確率S
    if S-rate >= random-float 1
    [
      ;発見者の懲罰確率V
      ifelse V-rate > random-float 1
      [
        ;もしiの裏切りを他者jから発見されていたらiは懲罰による痛手UPを払う
        ask turtle-i [set utility utility + UP ]
        ask turtle-i [set dtfg-i 1]
        ask turtle-i [set AgentPunishedNum AgentPunishedNum + 1]

        set utility utility + UE
        set AgentPunisherNum AgentPunisherNum + 1

        ;jの懲罰フラグをオンにする
        set dtfg-j 1
      ][

      ]

      ;------meta-norms-game(メタ規範ゲーム)-----
      let group-k other turtles

      if meta-norm-game = true
      [
        meta-norm-game-defection group-j group-k
      ]
    ]
  ]

end


to meta-norm-game-defection [group-j group-k]
  ;------meta-norms-game(裏切りメタ規範ゲーム)------
  ask group-k
  [
    let q count group-j
    while [q > 0]
    [
      let turtle-j one-of group-j
      if S-rate > random-float 1
      [
        ;If agent j punishes agent i (jがiを懲罰したかどうか)
        ifelse [dtfg-j] of turtle-j > 0
        [
          ask turtle-j
            [
              set group-j other group-j
              set q q - 1
            ]
        ][
          ;If agent j does not punish agent i, agents of group-j punish agent j by probability V-rate(懲罰確率Vで懲罰UPを与える)
          ifelse V-rate > random-float 1
          [
            ;Punisher pay enforcement "UE"(発見者jに懲罰コストUEを払わせる)
            set utility utility + UE
            ask turtle-j
            [
              set utility utility + UP
              set group-j other group-j
              set q q - 1
            ]
          ][
            ask turtle-j
            [
              set group-j other group-j
              set q q - 1
            ]
          ]
        ]
      ]
    ]
  ]
end

To calcStandardDeviation
  ;*Caluculate standard deviation(標準偏差演算)
  ask turtles
  [
    ;set cummulative value tp Average-*-rate(累積値を格納)
    set Average-V-rate Average-V-rate + V-rate
    set Average-B-rate Average-B-rate + B-rate
    set Average-utility Average-utility + utility
  ]

  ;Calculate Average(平均演算)
  set Average-V-rate Average-V-rate / (count turtles)
  set Average-B-rate Average-B-rate / (count turtles)
  set Average-utility Average-utility / (count turtles)

  ask turtles
  [
    ;Calculate cumulative-variance (分散合計演算)
    set comulative-variance comulative-variance + ((Average-utility - utility)^ 2)
  ]

  ;*Caluculate sandard deviation (標準偏差演算)
  set standardDeviation (comulative-variance / (count turtles)) ^ (1 / 2)

  if data_discharge_per_steps = True
  [
    let resultGlobalBV-list []
    set resultGlobalBV-list lput number resultGlobalBV-list
    set resultGlobalBV-list lput UP resultGlobalBV-list
    set resultGlobalBV-list lput behaviorspace-run-number resultGlobalBV-list
    set resultGlobalBV-list lput ticks resultGlobalBV-list
    set resultGlobalBV-list lput RCTnum resultGlobalBV-list
    set resultGlobalBV-list lput Average-B-rate resultGlobalBV-list
    set resultGlobalBV-list lput Average-V-rate resultGlobalBV-list
    set resultGlobalBV-list lput Average-utility resultGlobalBV-list
    set resultGlobalBV-list lput standardDeviation resultGlobalBV-list

    file-open "ExperimentGlobalBV.txt"
    file-show resultGlobalBV-list
    file-close
  ]

end


to evolution
  ;Evolution(進化)
  ask turtles
  [
    set B-rate-initial B-rate
    set V-rate-initial V-rate

    ifelse utility > (Average-utility + standardDeviation)
    [
      set label "overSD"
      set SDstatus1 1
      set SDstatus2 1
    ][
      ifelse utility < (Average-utility - standardDeviation)
      [
        set label "underSD"
        set SDstatus1 -1
        set SDstatus2 -1
      ][
        set label "average"
        set SDstatus1 0
        set SDstatus2 0
      ]
    ]
  ]

  let group-overSD turtles with [label = "overSD"]
  let group-underSD turtles with [label = "underSD"]
  let group-average turtles with [label = "average"]
  let l count group-overSD
  let m count group-underSD
  let u count group-average
  let n min list l m
  let t min list (m - l) u
  let v min list (l - m) u

  set group-average sort-on [utility] group-average

  ifelse l < m
  [
    while [t > 0]
    [
      let turtle-average one-of group-average
      ask turtle-average [set label "overSD"]
      ask turtle-average [set SDstatus2 1]
      set group-average remove-item 0 group-average
      set t t - 1
    ]
  ][
    if l > m
    [
      while [v > 0]
      [
        let turtle-average one-of group-average
        ask turtle-average [set label "underSD"]
        ask turtle-average [set SDstatus2 -1]
        set group-average remove-item 0 group-average
        set v v - 1
      ]
    ]
  ]

  set group-overSD turtles with [label = "overSD"]
  set group-underSD turtles with [label = "underSD"]
  set l count group-overSD
  set m count group-underSD
  set n min list l m
  set overSDagentNum count group-overSD
  set underSDagentNum count group-underSD

  set group-overSD sort-on [(- utility)] group-overSD
  set group-underSD sort-on [utility] group-underSD

  while [n > 0]
  [
    let max-B-rate [B-rate] of item 0 group-overSD
    let max-V-rate [V-rate] of item 0 group-overSD
    let max-C-rate [C-rate] of item 0 group-overSD

    let min-parent item 0 group-underSD

    ask min-parent
    [
      set B-rate max-B-rate
      set V-rate max-V-rate
    ]

      set group-overSD remove-item 0 group-overSD
      set group-underSD remove-item 0 group-underSD
      set n n - 1
    ]

  ask turtles
  [
    set B-rate-evolution B-rate
    set V-rate-evolution V-rate
  ]

  ask turtles
  [
    ;Mutation(突然変異)
    if mutation-rate * 6 > random-float 1
    [
      ifelse random-float 1 > 0.5
      [
        set B-rate (random 7.5) / 7
      ][
        set V-rate (random 7.5) / 7
      ]
    ]
  ]

  ask turtles
  [
    set B-rate-mutate B-rate
    set V-rate-mutate V-rate
  ]

  if data_discharge_per_steps = True
  [
    ask turtles
    [
      let resultAgentStrtegyTrans-list[]
      set resultAgentStrtegyTrans-list lput number resultAgentStrtegyTrans-list
      set resultAgentStrtegyTrans-list lput UP resultAgentStrtegyTrans-list
      set resultAgentStrtegyTrans-list lput behaviorspace-run-number resultAgentStrtegyTrans-list
      set resultAgentStrtegyTrans-list lput ticks resultAgentStrtegyTrans-list
      set resultAgentStrtegyTrans-list lput SDstatus1 resultAgentStrtegyTrans-list
      set resultAgentStrtegyTrans-list lput SDstatus2 resultAgentStrtegyTrans-list
      set resultAgentStrtegyTrans-list lput B-rate-initial resultAgentStrtegyTrans-list
      set resultAgentStrtegyTrans-list lput B-rate-evolution resultAgentStrtegyTrans-list
      set resultAgentStrtegyTrans-list lput B-rate-mutate resultAgentStrtegyTrans-list
      set resultAgentStrtegyTrans-list lput V-rate-initial resultAgentStrtegyTrans-list
      set resultAgentStrtegyTrans-list lput V-rate-evolution resultAgentStrtegyTrans-list
      set resultAgentStrtegyTrans-list lput V-rate-mutate resultAgentStrtegyTrans-list
      set resultAgentStrtegyTrans-list lput utility resultAgentStrtegyTrans-list
      set resultAgentStrtegyTrans-list lput CooperateNum resultAgentStrtegyTrans-list
      set resultAgentStrtegyTrans-list lput DefectNum resultAgentStrtegyTrans-list
      set resultAgentStrtegyTrans-list lput AgentPunisherNum resultAgentStrtegyTrans-list
      set resultAgentStrtegyTrans-list lput AgentPunishedNum resultAgentStrtegyTrans-list

      file-open "ExperimentAgentStrtegyTrans.txt"
      file-show resultAgentStrtegyTrans-list
    ]
    file-close
  ]

end
@#$#@#$#@
GRAPHICS-WINDOW
616
10
756
159
-1
-1
4.0
1
11
1
1
1
0
0
0
1
-16
16
-17
17
0
0
0
ticks
30.0

BUTTON
12
10
105
43
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
106
10
197
43
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

MONITOR
12
44
105
89
NIL
count turtles
17
1
11

MONITOR
106
44
197
89
green patches
count patches with [pcolor = green]
17
1
11

INPUTBOX
429
11
518
71
length-of-run
1000.0
1
0
Number

MONITOR
198
44
279
89
NIL
ticks
17
1
11

BUTTON
198
10
279
43
go once
go
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
9
531
656
750
av Agent Utility
NIL
NIL
0.0
100.0
-10.0
6.0
true
false
"" ""
PENS
"Utility" 1.0 0 -16777216 true "" "plot Average-utility"

INPUTBOX
520
10
610
70
number
20.0
1
0
Number

PLOT
1
281
649
522
av B/V-rate
NIL
NIL
0.0
10.0
0.0
0.5
true
true
"" ""
PENS
"B-rate" 1.0 0 -16777216 true "" "plot Average-B-rate"
"V-rate" 1.0 0 -2674135 true "" "plot Average-V-rate"

INPUTBOX
433
73
522
133
UT
3.0
1
0
Number

INPUTBOX
434
134
522
194
UH
-1.0
1
0
Number

INPUTBOX
525
72
607
132
UE
-2.0
1
0
Number

INPUTBOX
526
134
609
194
UP
-9.0
1
0
Number

INPUTBOX
339
74
429
134
UF
0.0
1
0
Number

INPUTBOX
338
136
431
196
UM
0.0
1
0
Number

INPUTBOX
305
10
415
70
mutation-rate
0.01
1
0
Number

CHOOSER
10
103
148
148
model-change
model-change
"axelrod" "collusion"
0

SWITCH
154
162
313
195
meta-norm-game
meta-norm-game
0
1
-1000

CHOOSER
10
161
148
206
model-change-2
model-change-2
"strong" "weak"
0

SWITCH
155
109
299
142
S-rate-change
S-rate-change
0
1
-1000

INPUTBOX
337
202
429
262
initial-B-rate
4.0
1
0
Number

INPUTBOX
434
202
525
262
initial-V-rate
0.0
1
0
Number

MONITOR
619
166
729
211
norm-establishment
norm-establishment
17
1
11

MONITOR
621
218
730
263
norm-collapse
norm-collapse
17
1
11

SWITCH
7
213
210
246
data_discharge_per_steps
data_discharge_per_steps
1
1
-1000

@#$#@#$#@
## WHAT IS IT?

(a general understanding of what the model is trying to show or explain)

## HOW IT WORKS

(what rules the agents use to create the overall behavior of the model)

## HOW TO USE IT

(how to use the model, including a description of each of the items in the Interface tab)

## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
0
Rectangle -7500403 true true 151 225 180 285
Rectangle -7500403 true true 47 225 75 285
Rectangle -7500403 true true 15 75 210 225
Circle -7500403 true true 135 75 150
Circle -16777216 true false 165 76 116

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.1.1
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="experimentJACIII_LF_B00_V07_n20_1000_norm" repetitions="50" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <metric>Average-B-rate</metric>
    <metric>Average-V-rate</metric>
    <metric>norm-establishment</metric>
    <metric>norm-collapse</metric>
    <enumeratedValueSet variable="model-change">
      <value value="&quot;collusion&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="model-change-2">
      <value value="&quot;strong&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Leader-mode">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="B-rate-num0">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="V-rate-num0">
      <value value="7"/>
    </enumeratedValueSet>
    <steppedValueSet variable="B-rate-num" first="0" step="1" last="7"/>
    <steppedValueSet variable="V-rate-num" first="0" step="1" last="7"/>
    <enumeratedValueSet variable="number">
      <value value="20"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="LeaderNum">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="length-of-run">
      <value value="1000"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experimentJACIII_LF_B00_V07_n20_100_norm" repetitions="50" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <metric>Average-B-rate</metric>
    <metric>Average-V-rate</metric>
    <metric>norm-establishment</metric>
    <metric>norm-collapse</metric>
    <metric>Average-B-rate-10</metric>
    <metric>Average-B-rate-20</metric>
    <metric>Average-B-rate-30</metric>
    <metric>Average-B-rate-40</metric>
    <metric>Average-B-rate-50</metric>
    <metric>Average-B-rate-60</metric>
    <metric>Average-B-rate-70</metric>
    <metric>Average-B-rate-80</metric>
    <metric>Average-B-rate-90</metric>
    <enumeratedValueSet variable="model-change">
      <value value="&quot;collusion&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="model-change-2">
      <value value="&quot;strong&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Leader-mode">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="B-rate-num0">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="V-rate-num0">
      <value value="7"/>
    </enumeratedValueSet>
    <steppedValueSet variable="B-rate-num" first="0" step="1" last="7"/>
    <steppedValueSet variable="V-rate-num" first="0" step="1" last="7"/>
    <enumeratedValueSet variable="number">
      <value value="20"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="LeaderNum">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="length-of-run">
      <value value="100"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experimentJACIII_LF_n20_500_norm_timeseries" repetitions="50" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>Average-B-rate</metric>
    <metric>Average-V-rate</metric>
    <enumeratedValueSet variable="model-change">
      <value value="&quot;collusion&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="model-change-2">
      <value value="&quot;strong&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Leader-mode">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="B-rate-num0">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="V-rate-num0">
      <value value="7"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="B-rate-num">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="V-rate-num">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="20"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="length-of-run">
      <value value="500"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experimentJCMSI_LF_P3E1T3_n20_1000_norm_timeseries" repetitions="50" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>Average-B-rate</metric>
    <metric>Average-V-rate</metric>
    <metric>norm-establishment</metric>
    <metric>norm-collapse</metric>
    <metric>Count-V-7/7</metric>
    <metric>Count-V-6/7</metric>
    <metric>Count-V-5/7</metric>
    <metric>Count-V-4/7</metric>
    <metric>Count-V-3/7</metric>
    <metric>Count-V-2/7</metric>
    <metric>Count-V-1/7</metric>
    <metric>Count-V-0/7-1</metric>
    <metric>Count-V-0/7-0</metric>
    <metric>Count-B-7/7</metric>
    <metric>Count-B-6/7</metric>
    <metric>Count-B-5/7</metric>
    <metric>Count-B-4/7</metric>
    <metric>Count-B-3/7</metric>
    <metric>Count-B-2/7</metric>
    <metric>Count-B-1/7</metric>
    <metric>Count-B-0/7-1</metric>
    <metric>Count-B-0/7-0</metric>
    <metric>Average-utility</metric>
    <metric>utility450</metric>
    <metric>utility400</metric>
    <metric>utility350</metric>
    <metric>utility300</metric>
    <metric>utility250</metric>
    <metric>utility200</metric>
    <metric>utility150</metric>
    <metric>utility100</metric>
    <metric>utility090</metric>
    <metric>utility080</metric>
    <metric>utility070</metric>
    <metric>utility060</metric>
    <metric>utility050</metric>
    <metric>utility040</metric>
    <metric>utility030</metric>
    <metric>utility020</metric>
    <metric>utility010</metric>
    <metric>utility005</metric>
    <metric>utility000</metric>
    <metric>utilityPlus</metric>
    <metric>CooperateAgentNum</metric>
    <metric>DefectAgentNum</metric>
    <metric>PunisherNum</metric>
    <metric>PunishedNum</metric>
    <metric>standardDeviation</metric>
    <metric>overSDagentNum</metric>
    <metric>underSDagentNum</metric>
    <enumeratedValueSet variable="model-change">
      <value value="&quot;collusion&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="model-change-2">
      <value value="&quot;strong&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="S-rate-change">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="meta-norm-game">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Leader-mode">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="B-rate-num">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="V-rate-num">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="20"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="length-of-run">
      <value value="1000"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="UT">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="UE">
      <value value="-1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="UP">
      <value value="-3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="data_discharge_per_steps">
      <value value="true"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experimentJCMSI_LF_P3E1T3_n40_1000_norm_timeseries" repetitions="50" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>Average-B-rate</metric>
    <metric>Average-V-rate</metric>
    <metric>norm-establishment</metric>
    <metric>norm-collapse</metric>
    <metric>Count-V-7/7</metric>
    <metric>Count-V-6/7</metric>
    <metric>Count-V-5/7</metric>
    <metric>Count-V-4/7</metric>
    <metric>Count-V-3/7</metric>
    <metric>Count-V-2/7</metric>
    <metric>Count-V-1/7</metric>
    <metric>Count-V-0/7-1</metric>
    <metric>Count-V-0/7-0</metric>
    <metric>Count-B-7/7</metric>
    <metric>Count-B-6/7</metric>
    <metric>Count-B-5/7</metric>
    <metric>Count-B-4/7</metric>
    <metric>Count-B-3/7</metric>
    <metric>Count-B-2/7</metric>
    <metric>Count-B-1/7</metric>
    <metric>Count-B-0/7-1</metric>
    <metric>Count-B-0/7-0</metric>
    <metric>Average-utility</metric>
    <metric>utility450</metric>
    <metric>utility400</metric>
    <metric>utility350</metric>
    <metric>utility300</metric>
    <metric>utility250</metric>
    <metric>utility200</metric>
    <metric>utility150</metric>
    <metric>utility100</metric>
    <metric>utility090</metric>
    <metric>utility080</metric>
    <metric>utility070</metric>
    <metric>utility060</metric>
    <metric>utility050</metric>
    <metric>utility040</metric>
    <metric>utility030</metric>
    <metric>utility020</metric>
    <metric>utility010</metric>
    <metric>utility005</metric>
    <metric>utility000</metric>
    <metric>utilityPlus</metric>
    <metric>CooperateAgentNum</metric>
    <metric>DefectAgentNum</metric>
    <metric>PunisherNum</metric>
    <metric>PunishedNum</metric>
    <metric>standardDeviation</metric>
    <metric>overSDagentNum</metric>
    <metric>underSDagentNum</metric>
    <enumeratedValueSet variable="model-change">
      <value value="&quot;collusion&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="model-change-2">
      <value value="&quot;strong&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="S-rate-change">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="meta-norm-game">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Leader-mode">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="B-rate-num">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="V-rate-num">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="40"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="length-of-run">
      <value value="1000"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="UT">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="UE">
      <value value="-1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="UP">
      <value value="-3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="data_discharge_per_steps">
      <value value="true"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
